// Copyright (C) 2006, Ondra Kamenik

// $Id: dynare_exception.h 762 2006-05-22 13:00:07Z kamenik $

#ifndef DYNARE_EXCEPTION_H
#define DYNARE_EXCEPTION_H

#include <string>

class DynareException {
	char* mes;
public:
	DynareException(const char* m, const char* fname, int line, int col)
		{
			mes = new char[strlen(m) + strlen(fname) + 50];
			sprintf(mes, "Parse error at %s, line %d, column %d: %s", fname, line, col, m);
		}
	DynareException(const char* fname, int line, const std::string& m)
		{
			mes = new char[m.size() + strlen(fname) + 50];
			sprintf(mes, "%s:%d: %s", fname, line, m.c_str());
		}
	virtual ~DynareException()
		{delete [] mes;}
	const char* message() const
		{return mes;}
};

#endif

// Local Variables:
// mode:C++
// End:
