// $Id: dynare_params.h 431 2005-08-16 15:41:01Z kamenik $

// Copyright 2004, Ondra Kamenik

/*
along shocks: m    mult    max_evals
ellipse:      m    mult    max_evals  (10*m) (0.5*mult)
simul:        m            max_evals  (10*m)

--check-scale 2.0 --check-evals 1000 --check-num 10 --check PES
 */

struct DynareParams {
	const char* modname;
	char basename[100];
	int num_per;
	int num_sim;
	int num_threads;
	int num_steps;
	const char* prefix;
	int seed;
	bool check_along_path;
	bool check_along_shocks;
	bool check_on_ellipse;
	int check_evals;
	int check_num;
	double check_scale;
	bool do_irfs;
	bool help;
	bool version;
	DynareParams(int argc, char** argv);
	void printHelp() const;
	int getCheckShockPoints() const
		{return check_num;}
	double getCheckShockScale() const
		{return check_scale;}
	int getCheckEllipsePoints() const
		{return 10*check_num;}
	double getCheckEllipseScale() const
		{return 0.5*check_scale;}
	int getCheckPathPoints() const
		{return 10*check_num;}
private:
	enum {opt_per, opt_sim, opt_prefix, opt_threads, opt_steps, opt_seed, opt_check,
		  opt_check_along_path, opt_check_along_shocks, opt_check_on_ellipse,
		  opt_check_evals, opt_check_scale, opt_check_num, opt_noirfs, opt_irfs,
		  opt_help, opt_version};
	void processCheckFlags(const char* flags);
};

// Local Variables:
// mode:C++
// End:
